;******************************************************************************
;* 
;*
;* 13-11-2000	V 0.1		Primera adaptacin
;* 16-11-2000	V 0.2		Solucionado un bug en comunicacion I2C
;* 16-11-2000	V 0.3		Incorporacin de la Tabla2 del algoritmo de
;*							encriptacin en el codigo de pic
;* 20-11-2000	V 0.4		Aadido Encriptacin
;* 21-11-2000   V 0.5		Aadido Chequeo de la firma
;* 04-12-2000   V 0.6		Aadido Gestin de los Nanos principales
;* 06-12-2000   V 1.0		Gestion de los datos de la eeprom externa en la
;*							propia Flash del F876
;* 08-12-2000   V 1.1		Bloqueo de canales
;* 08-12-2000	V 1.2		Proteccin de los comandos de actualizacin
;*							- Presentacin Password 8 bytes C1 30 0F 00 08 d0 ... d7
;*							- Lectura Memoria Flash de Programa C1 24 HighAddress LowAddress LEN
;*							- Escritura Memoria Flash de Programa C1 26 HighAddress LowAddress LEN
;*							- Ejecutar Memoria Flash de Programa C1 28 HighAddress LowAddress 00
;*							- Configuracin y testeo de leds desde mando a distancia
;*							- EEPROM externa  FLASH interno configurable
;*							- Log Selectivo de comandos
;*							- Envio del Trafico CAM<->Tarjeta por RC6/TX
;* 18-12-2000	V 1.2b		Volcado de Flash Interna a EEPROM externa Cdigo Remoto 0011
;* 18-12-2000	V 1.2c		Volcado de EEPROM externa a Flash Interna Cdigo Remoto 0012
;* 18-12-2000	V 1.2d		Deshabiliar las funciones anteriores si no hay EEPROM
;* 29-12-2000   V 1.3		Cambio en la interpretacin del CUSTWP-Bitmap
;*							Solucionado Bug en la desencriptacin de comandos cuando la longitud
;*								era multiplo de 8
;*							Solucionado Bug en las funciones Store y Restore cuando se llegaba a la frontera de 80 bytes
;*							Suprimido Log Selectivo de comandos
;* 02-01-2001	V 1.4		Activacin del nano 41 (Actualizacin PPUA)
;*							Aadido Comando 0Ah
;* 13-01-2001   V 1.4c      Log selectivo de comando 40 para proveedores distintos del 00 (SECA)
;* 19-01-2001	V 1.5		Log de comandos utilizando mascara
;*							Contador de bytes capturados
;*							Indicacin del estado del buffer para logs mediante los leds 2 y 3
;*							Procesamiento de nanos en INS 3C
;*							Arreglado bug en transmisin de comandos -> TNANKS Atmel
;*							Nuevos codigos remotos
;*									- 0013 Activacion captura de comandos
;*									- 0014 Desactivacion captura de comandos
;*									- 0015 Borrado almacen captura de comandos
;* 21-01-2001               Ignorar el ultimo byte de la PPUA si este es cero *RASMA*
;* 23-01-2001				Tratamiento de la nano 80 *RASMA*
;******************************************************************************
            		LIST      	P=16F876, F=INHX8M
            		include 	"P16F876.inc"

        			__CONFIG    _BODEN_OFF & _CP_OFF & _WRT_ENABLE_ON & _PWRTE_OFF & _WDT_OFF & _XT_OSC & _DEBUG_OFF & _CPD_OFF & _LVP_OFF 

;******************************************************
; EQU
;******************************************************
YEAR			EQU		.2001
MONTH			EQU		.1
DAY				EQU		.19

#define			DATE 	((YEAR-.1990)*.512+MONTH*.32+DAY)


SDA				EQU		4
SCL				EQU		5
I_O				EQU		7
;******************************************************
; GPR
				ORG		0x20

EEDATA2			RES		1
EEADRH2			RES		1
EEADR2			RES		1		
CONTROL			RES		1	;Bit 0		Flag modo programacin se habilitan las instrucciones de actualizacin
							;Bit 1		Activado = Leds en catodo comn
							;Bit 2		Activado = Usar eeprom externa
							;Bit 3		Activado = Proteccin de Actualizacin de Claves
							;Bit 4		Activado = Log
							;Bit 5		Activo 	 = Capturar comando
							;Bit 6		Activado = No se ha encontrado EEPROM externa
							;Bit 7		Activado = Responder 901D
LEDS			RES		1
COUNTER			RES		1
DUMMY1			RES		1
DUMMY2			RES		1
DUMMY3			RES		1
DUMMY4			RES		1
FSR2			RES		1

				ORG		0x2B

IC_CLA			RES		1		
IC_INS			RES		1
IC_P1			RES		1
IC_P2			RES		1
IC_P3			RES		1

BUFFER2			RES		0x10
PK				RES		8
SK				RES		8
BUFFER			RES		0x10
F40				RES		1
TEMP			RES		8
CONTROL2		RES		1	;Bit 0		Activado = From Card to CAM
							;Bit 1		Activado = Datos en Log
							;Bit 2		Activado = Log lleno
							;Bit 3		Activado = Procesado Nano D1
;**************************************************************************************************
;* INICIO                                                                                         *
;**************************************************************************************************
            	ORG     0x0000
				goto	Init
				ORG		0x0004
				retfie
Init
            	call    Std_pause
            	movlw	0xF0
            	tris	PORTA
            	movlw	0xF0
            	movwf	PORTA 
            	clrf	LEDS
            	movlw	0x7F
            	option      
            	clrf	CONTROL
            	clrf	CONTROL2

				movlw	0x7E
				call	Rd_eeprom		;Leemos Configuracin envio trfico
				bsf		STATUS,RP0		;Selects Bank 1
				movwf	SPBRG
				movf	SPBRG,F			;Miramos si es cero
				bsf		TXSTA,TXEN
				bcf		STATUS,RP0		;Back to Bank 0
				btfss	STATUS,Z
				bsf		RCSTA,SPEN


				movlw	0x00			;Leemos el ConfigByte
				call	Rd_eeprom
				movwf	CONTROL
				call	i2c_test		;Miramos si hay eeprom externa
				btfsc	STATUS,C		;Si no la hay
				bsf		CONTROL,6		;Marcamos el Flag 6
				btfsc	STATUS,C		;Si no la hay
				bcf		CONTROL,2		;Forzamos Flag Flash interna
				bcf		CONTROL,5		;Desctivamos el Flag de Captura de Comando
			            	            	
;Lee los bytes de ATR almacenados en la eeprom del pic en orden inverso, comenzando en la posicin
;0x0E un total de 0x10 bytes

            	movlw   0x0E
            	movwf   COUNTER
ATR_loop    
				movf    COUNTER,W   
            	call    Rd_eeprom
            	call    Send     
            	decfsz  COUNTER,f    
            	goto    ATR_loop             	
            	goto	TX90XX
;**************************************************************************************************
;Si el bit 7 de CONTROL vale 1 se devuelve un 901D y si vale 0 se devuelve un 9000
;La respuesta 901D se devuelve cuando se recibe un comando C140 que no contiene claves porque reduce el
;trfico de mensajes entre cam y card

TX90XX      
				movlw  	0x90
TXxx001D    
				call    Send
            	movlw   0x00          	;9000
            	btfsc   CONTROL,7
            	movlw   0x1D          	;901D
            	call    Send

Main
            	bcf     CONTROL,7		;Restablecer flag 7
            	clrf	EEADRH2

            	movf	LEDS,W
				btfss	CONTROL,1		;Tipo de Led
            	xorlw	0x0F
            	movwf	PORTA

				clrf	PCLATH
;Leemos la cabecera del comando
				call	GetCommandHeader

				movlw	0xC1
				xorwf	IC_CLA,W
				btfss	STATUS,Z
				goto	Invalid_CLA		;Si Clase no es C1 enviar 6E00

            	movlw   .17        		;Hay 17 instrucciones
            	movwf   TEMP+1          	;contador de instrucciones
Comm_scan   
				movf    TEMP+1,W
            	addlw   0x0E      		;offset w internal EEPROM
            	call    Rd_eeprom     	;Lee el codigo de instruccion
            	xorwf   IC_INS,W
            	btfsc   STATUS,Z      	;Si es el que se ha recibido
            	goto    Send_ack      	;envia el ACK y lo procesa
            	decfsz  TEMP+1,f        	;Decrementa la variable del bucle
            	goto    Comm_scan     	;/ y si no es cero vuelve a hacer otra iteracin

        	    bsf		CONTROL2,0		;From Card to CAM
            	call	Log				;Capturo esa instruccion

            	bsf		LEDS,2			;Activamos el led 2
            	goto    TX6D00			;Si no se conoce la instr. devolver 6D00 
Invalid_CLA            	
            	bsf		LEDS,2			;Activamos el led 2

            	bsf		CONTROL2,0		;From Card to CAM
            	call	Log				;Capturo esa instruccion
				movlw	0x6E			;Si no se conoce la clase devolver 6E00
				goto	TXxx001D
Send_ack    
				clrf	PCLATH
				movf    IC_INS,W
            	call    Send          	;Envia el ACK
            	movf    TEMP+1,W
	            addlw   InsTable
InsTable    
				movwf   PCL
            	goto    Instr_0E
            	goto    Instr_16
            	goto    Instr_12
            	goto    Instr_34
            	goto    Instr_32
            	goto    Instr_22		;Escribe Datos a la flash o eeprom interna o externa
            	goto    Instr_30
            	goto    Instr_20		;Leer Datos de la Flash o eeprom interna o externa
            	goto    Instr_3A
            	goto    Instr_3C
            	goto    Instr_40
            	goto    Instr_1A
            	goto	Instr_5A
            	goto    Instr_24		;Leer Flash de Programa
            	goto	Instr_26		;Escribir Flash de Programa
            	goto	Instr_28		;Ejecutar Flash de Programa
            	goto	Instr_0A
Remote_Table            	
				addwf   PCL,F
            	goto    Remote_00
            	goto    Remote_01
            	goto    Remote_02
            	goto    Remote_03
            	goto    Remote_04
            	goto    Remote_05
            	goto    Remote_06
            	goto    Remote_07
            	goto    Remote_08
            	goto    Remote_09
            	goto    Remote_10
            	goto    Remote_11
            	goto    Remote_12
            	goto    Remote_13
            	goto    Remote_14
            	goto    Remote_15
;**************************************************************************************************
Send        
				movwf	TXREG			;Para el envio de trfico
				movwf   TEMP+6
            	movlw   0x32
            	call    Pause
            	movlw   B'01111111'
            	tris    PORTB        ;/ Define PORT B I/O RB7=output
            	clrf    TEMP+7
            	bcf     PORTB,7     ; wystaw bit startu
            	movlw   0x08         ;\
            	movwf   TEMP+4         ;/ length ilosci bitow
send_loop   
				call    Std_pause    ; czas jednego bitu
            	rrf     TEMP+6,f       ; pobierz dana  
            	rrf     TEMP+6,W
            	andlw   0x80
            	xorwf   TEMP+7,f       ; suma kontrolna
            	xorwf   PORTB,W
            	xorwf   PORTB,f
            	decfsz  TEMP+4,f
            	goto    send_loop
            	call    Std_pause
            	movf    TEMP+7,W       ;Envia la paridad
            	xorwf   PORTB,W
            	xorwf   PORTB,f
            	call    Std_pause
            	movlw   B'11111111'  ;\ Define PORT B I/O = input
            	tris    PORTB        ;/
            	movlw   0x4F         ;\ parametr czasu
            	goto    Pause        ;/ 2 bity stopu
;**************************************************************************************************
Receive     
				btfsc   PORTB,7
            	goto    Receive        	;Esperamos el start bit
            	movlw   0x2A
            	call    Pause
            	movlw   0x09
            	movwf   TEMP+4
Receive_loop 
            	bcf     STATUS,C
            	btfsc   PORTB,7
            	bsf     STATUS,C
            	rrf     TEMP+6,f   
            	call    Std_pause
            	decfsz  TEMP+4,f
            	goto    Receive_loop
            	rlf     TEMP+6,f
            	movlw   0x28
            	call    Pause
            	movf    TEMP+6,W
				movwf	TXREG			;Para el envio de trfico
            	return
;**************************************************************************************************
Std_pause   
				movlw   0x1A        	;Pausa estndar para enviar/recibir con protocolo serie
Pause       
				movwf   TEMP+5     		;Hace una pausa del tiempo indicado en W
Pause_loop  
				decfsz  TEMP+5,f
            	goto    Pause_loop
            	retlw   0x00           	

;**************************************************************************************************
;* LEER UN BYTE DE LA EEPROM DEL PIC															  *
;**************************************************************************************************
;* W = Direccin y Byte leido al salir   														  *
;**************************************************************************************************
Rd_eeprom   
				bsf		STATUS,RP1		;Select Bank 2
				movwf   EEADR
            	bsf     STATUS,RP0      ;Select Bank 3
            	bcf		EECON1,EEPGD
            	bsf     EECON1,RD
            	bcf     STATUS,RP0      ;Select Bank 2
            	movf    EEDATA,W
            	bcf		STATUS,RP1		;Select Bank 0
            	return
;**************************************************************************************************
;* ESCRIBE UN BYTE A LA EEPROM DEL PIC															  *
;**************************************************************************************************
;* EEADR2 = Direccin  W=Dato																	  *
;**************************************************************************************************
Wr_eeprom   
				bcf		PIR2,EEIF
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEDATA
				bcf		STATUS,RP1		;Select Bank 0
				movf	EEADR2,W
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEADR
				bsf		STATUS,RP0		;Select Bank 3
				bcf		EECON1,EEPGD
				bsf		EECON1,WREN
				movlw	0x55
				movwf	EECON2
				movlw	0xAA
				movwf	EECON2
				bsf		EECON1,WR
				bcf		STATUS,RP0		
				bcf		STATUS,RP1		;Select Bank 0

				btfss	PIR2,EEIF
				goto	$-1

				bsf		STATUS,RP0
				bsf		STATUS,RP1		;Select Bank 3

				bcf		EECON1,WREN
				bcf		STATUS,RP0
				bcf		STATUS,RP1		;Select Bank 0
				return
;**************************************************************************************************
;Envia la cadena de datos contenida en la FLASH del 876 a travs del puerto serie
;La direccin viene en W la parte baja y en EEADRH2 la alta. En IC_P3 est el nmero de bytes a enviar
;**************************************************************************************************
FLASH_send 
				movwf	EEADR2
FLASH_send_loop
            	decf    IC_P3,f        ;Decrementa contador
            	btfsc   IC_P3,7        ;Si es negativo ha acabado y retorna 
            	return

				movf	EEADR2,W
            	call    Rd_Memory       ; lee dato
            	incf	EEADR2,F
            	call    Send           ; y lo enva
            	goto    FLASH_send_loop
;**************************************************************************************************
;* RUTINAS GESTION BUS I2C   																	  *
;**************************************************************************************************
i2c_test
				call	i2c_start
	    		movlw   0xA0		
	    		goto	i2c_write_byte
;--------------------------------------------------------------------
i2c_controlW 
				call	i2c_start
	    		movlw   0xA0		
	    		call	i2c_write_byte
	    		btfss	STATUS,C
	    		return
	    		goto	i2c_controlW
;--------------------------------------------------------------------
i2c_controlR
				call	i2c_start
	    		movlw   0xA1
	    		call	i2c_write_byte
	    		btfss	STATUS,C
	    		return
	    		goto	i2c_controlR
;--------------------------------------------------------------------
i2c_write_byte 
	    		movwf   EEDATA2
            	movlw   B'11001111'
            	tris    PORTB                ; Configura SDA como salida
            	call    i2c_write_nib
            	call    i2c_write_nib
            	goto    i2c_read_bit
i2c_write_nib  
	        	call    i2c_write_nib_2
	        	call    i2c_write_nib_2
            	call    i2c_write_nib_2
i2c_write_nib_2  
            	rlf     EEDATA2,f
            	goto    i2c_write_bit_x
;--------------------------------------------------------------------
i2c_read_byte    
				movlw   B'11011111'
            	tris    PORTB      		; Configura SDA como entrada
            	call    i2c_read_nib
            	call    i2c_read_nib
            	bsf     STATUS,C
            	goto    i2c_write_bit
i2c_read_nib   
				call    i2c_read_nib_2
            	call    i2c_read_nib_2
            	call    i2c_read_nib_2
i2c_read_nib_2 
				call    i2c_read_bit_x
            	rlf     EEDATA2,f
            	return
;--------------------------------------------------------------------
i2c_start   
				bsf     PORTB,4		;SDA -> High
            	movlw   B'11001111'
            	tris    PORTB        	;SDA como salida
            	bsf     PORTB,5		;SCL -> High
            	nop
            	bcf     PORTB,4		;SDA -> Low
            	nop
				bcf     PORTB,5		;SCL -> Low
            	return
;--------------------------------------------------------------------
i2c_stop    
				bcf     PORTB,4		;SDA -> Low
            	movlw   B'11001111'
            	tris    PORTB        	;SDA como salida
            	nop
            	bsf     PORTB,5		;SCL -> High
            	nop
            	bsf     PORTB,4		;SDA -> High
i2c_scl_low       
				nop
				bcf     PORTB,5		;SCL -> Low
            	return
;--------------------------------------------------------------------
i2c_write_bit  
				movlw   B'11001111'
            	tris    PORTB        	;SDA como salida
i2c_write_bit_x  
               	btfss   STATUS,C
            	bcf     PORTB,4		;SDA -> Low
            	btfsc   STATUS,C
            	bsf     PORTB,4		;SDA -> High
            	bsf     PORTB,5		;SCL -> High
            	goto    i2c_scl_low
;--------------------------------------------------------------------
i2c_read_bit    
				movlw   B'11011111'
            	tris    PORTB		;SDA as input
i2c_read_bit_x   
				bsf     PORTB,5		;SCL -> High
            	nop
            	bsf     STATUS,C
            	btfss   PORTB,4		;Test SDA
            	bcf     STATUS,C
				bcf     PORTB,5		;SCL -> Low
            	return
;**************************************************************************************************
;* Rutina que hace un swap de dos bloques de 8 bytes cada uno. W contiene la direccin de incio   *
;* de un bloque y EEADR2 el desplazamiento del segundo bloque respecto del primero. Si el         *
;* desplazamiento es positivo significa mover hacia atrs y si es negativo hacia adelante.        *
;**************************************************************************************************
xor_eedat   
				call    SwapData        ;Swap de dos bloques de 8 bytes
            	goto    c19Ac
SwapData       
				movwf   FSR          	;Swap de dos bloques de 4 bytes
c19Ac       
				call    c19Dc
            	call    c19Dc
            	call    c19Dc
c19Dc       
				movf    INDF,W       	;Swap de 1 byte
            	movwf   EEDATA2
            	movf    EEADR2,W
            	subwf   FSR,f
            	movf    EEDATA2,W
            	xorwf   INDF,f
            	movf    INDF,W
            	xorwf   EEDATA2,f
            	movf    EEDATA2,W
            	xorwf   INDF,f
            	movf    EEADR2,W
            	addwf   FSR,f
            	movf    EEDATA2,W
            	movwf   INDF
            	incf    FSR,f
            	return
;**************************************************************************************************
xor_24_30   
				movlw   0x24
            	movwf   EEADR2
            	movlw   BUFFER
            	call    xor_eedat
            	return
;**************************************************************************************************
xor_2C_38   
				movlw   0x2C
            	movwf   EEADR2
            	movlw   BUFFER+8
            	call    xor_eedat
            	return
;**************************************************************************************************
;Hace un swap del bloque 0x30-0x37 con el 0x0c-0x13
xor_F8_30   
				movlw   0xF8
xor_xx_30   
				movwf   EEADR2            ;;Swap de 30 con la diferencia indicada en W
            	movlw   BUFFER         
            	call    xor_eedat
            	return
;**************************************************************************************************
;Rutina de encriptacin SECA
;DUMMY3 es i apunta al elemento de la key que se est procesando (0x00..0x0f)
;DUMMY1 es la constante C
;BUFFER[8] contiene los datos a encriptar
;PK[8],SK[8] contiene la clave primaria y secundaria respectivamente
;**************************************************************************************************
Encrypt
            	clrf   	DUMMY1         	;C=0
            	clrf  	DUMMY3			;i=1
Encrypt_round       
            	call    InitKey       	;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
            	incf	DUMMY3,f		;i=i+1
            	call    InitKey       	;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
            	incf	DUMMY3,f		;i=i+1
            	call    InitKey       	;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
            	incf	DUMMY3,f		;i=i+1
            	call    InitKey       	;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
				movlw	3
				subwf	DUMMY3,f		;i=i-3
				call	crypt1
				incf	DUMMY3,f		;i=i+1
				call	crypt2
            	movf	DUMMY1,W		;C -> W
            	xorlw	0x0F			;
            	btfsc   STATUS,Z    	;Si C=15 retornar 
            	return					;Encriptacin terminada
            	movlw   0x04
            	movwf   EEADR2
            	movlw   BUFFER+4
            	call    SwapData       	;Swap de d[0]..d[3] con d[4]..d[7]
            	incf    DUMMY1,f      	;C=C+1
            	btfsc   DUMMY3,4		;Si i>15
            	clrf	DUMMY3			;i=0
            	goto    Encrypt_round	;Siguiente iteracin
;**************************************************************************************************
;Rutina de desencriptacin SECA
;DUMMY3 apunta al elemento de la key que se est procesando (0x00..0x0f)
;DUMMY1 es la constante C
;BUFFER[8] contiene los datos a encriptar
;PK[8],SK[8] contiene la clave primaria y secundaria respectivamente
;**************************************************************************************************
Decrypt     
				clrf    DUMMY3
            	clrf    DUMMY1
Decrypt_loop
            	call    InitKey       	;K[i]=K[i] XOR T1[K[i-1] XOR K[i+1] XOR C]
            	incf    DUMMY3,f       	;i=i+1 
            	movf    DUMMY3,W
            	andlw   0x03
            	btfsc   STATUS,Z
            	incf    DUMMY1,f       	;Cada 4 iteraciones del bucle incrementa la constante C
            	btfss   DUMMY3,6
            	goto    Decrypt_loop 	;Hacer 16*4 iteraciones

            	movlw   .15				;C=15
            	movwf   DUMMY1
            	movlw   .12         		;i=13
            	movwf   DUMMY3
Decrypt_round       
				call	crypt1
				call	crypt2

            	call    InitKey       	;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
            	decf	DUMMY3,F		;i=i-1
            	call    InitKey       	;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
            	decf	DUMMY3,F		;i=i-1
            	call    InitKey       	;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
            	decf	DUMMY3,F		;i=i-1
            	call    InitKey       	;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1]]
            	movf    DUMMY1,F
            	btfsc   STATUS,Z    	;Si C=0 retornar
            	return

            	movlw   0x04
            	movwf   EEADR2
            	movlw   BUFFER+4
            	call    SwapData       	;Swap de d[0]..d[3] con d[4]..d[7]
            	decf    DUMMY1,f      	;C=C-1
            	movlw   0xFC
            	addwf   DUMMY3,f      	;i=i-4
            	movlw   .12
            	btfsc   DUMMY3,7     	;Si i se ha vuelto negativo
            	movwf   DUMMY3        	;lo pone de nuevo a 12
            	goto    Decrypt_round
;**************************************************************************************************
crypt1
				call    ekey         	;W = K[i] XOR d5
            	xorwf   BUFFER+4,W       	
            	call    Tabla1
            	movwf   TEMP+0         	;TEMP+0=T1[W]
            	incf	DUMMY3,F		;i=i+1
            	call    ekey     		;W = K[i] XOR d6
            	xorwf   BUFFER+5,W
            	call    Tabla1
            	movwf   TEMP+1         	;TEMP+1=T1[W]
            	incf	DUMMY3,F		;i=i+1
            	call    ekey			;W = K[i] XOR d7
            	xorwf   BUFFER+6,W
            	call    Tabla1
            	movwf   TEMP+2         	;TEMP+2=T1[W]
            	incf	DUMMY3,F		;i=i+1
            	call    ekey			;W = K[i] XOR d8
            	xorwf   BUFFER+7,W
            	call    Tabla1
            	movwf   TEMP+3         	;TEMP+3=T1[W]
				return
;**************************************************************************************************
crypt2				
            	xorwf   TEMP+0,f       	;d5=d5 XOR d8
            	swapf   TEMP+3,W
            	addwf   TEMP+2,W       	;W=~d8+d7 
            	call    Tabla2        	;W=T2[W]
            	movwf   TEMP+2         	;TEMP+2=T2[W]
            	xorwf   TEMP+3,f       	;d[7]=d[7] XOR d[6]
            	swapf   TEMP+2,W
            	addwf   TEMP+1,W
            	call    Tabla2
            	movwf   TEMP+1         	;d[5]=T2[~d[6]+d[5]]
            	xorwf   TEMP+2,f       	;d[6]=d[6] XOR d[5]
            	swapf   TEMP+1,W
            	addwf   TEMP+0,W
            	call    Tabla2
            	movwf   TEMP+0        		;d[4]=T2[~d[5]+d[4]]
            	xorwf   TEMP+1,f      		;d[5]=d[5] XOR d[4]
            	swapf   TEMP+0,W
            	addwf   TEMP+3,W
            	call	Tabla1
            	movwf   TEMP+3        		;d[7]=T1[~d[4]+d[7]]
            	xorwf   TEMP+0,f      		;d[4]=d[4] XOR d[7]
            	swapf   TEMP+3,W
            	addwf   TEMP+2,W
            	call    Tabla1
            	movwf   TEMP+2        		;d[6]=T1[~d[7]+d[6]]
            	xorwf   TEMP+3,f      		;d[7]=d[7] XOR d[6]
            	swapf   TEMP+2,W
            	addwf   TEMP+1,W
            	call    Tabla1
            	movwf   TEMP+1        		;d[5]=T1[~d[6]+d[5]]
            	xorwf   TEMP+2,f      		;d[6]=d[6] XOR d[5]
            	movf    TEMP+0,W
            	xorwf   TEMP+1,f      		;d[5]=d[5] XOR d[4]

            	movf    TEMP+1,W
            	call    Tabla2
            	xorwf   BUFFER+0,f      ;d[0]=d[0] XOR T2[d[5]]
            	movf    TEMP+3,W
            	call    Tabla2
            	xorwf   BUFFER+1,f      ;d[1]=d[1] XOR T2[d[7]]
            	movf    TEMP+0,W
            	call	Tabla2
            	xorwf   BUFFER+2,f      ;d[2]=d[2] XOR T2[d[4]] 
            	movf    TEMP+2,W
            	call    Tabla2
            	xorwf   BUFFER+3,f      ;d[3]=d[3] XOR T2[d[6]]
            	clrf	PCLATH
            	return
;**************************************************************************************************
;* K[i]=K[i] XOR T1[K[i-1] XOR K[i+1] XOR C]
InitKey       
				incf    DUMMY3,W
            	call    ekeyW
            	movwf   DUMMY2     		;K[i+1]
            	decf    DUMMY3,W
            	call    ekeyW    
            	xorwf   DUMMY2,f   		;K[i+1] XOR K[i-1]
            	call    ekey     		;No usa el resultado, pero hace que FSR apunte al elemento indicado por 0x0f
            	movf    DUMMY2,W   
            	xorwf   DUMMY1,W   		;K[i+1] XOR K[i-1] XOR C
            	call    Tabla1 			;T1[K[i+1] XOR K[i-1] XOR C]
            	xorwf   INDF,f   		;K[i]=K[i] XOR T1[K[i+1] XOR K[i-1] XOR C]
            	return
;**************************************************************************************************
;* W = K[i]
ekey        
				movf    DUMMY3,W     	;i -> W
ekeyW       
				andlw   0x0F        	;Devuelve el elemento apuntado en W. El AND controla el wrap (por si el indice mayor de 0x0f)
				addlw	PK				;La key est almacenada en PK
            	movwf   FSR
            	movf    INDF,W
            	return
;**************************************************************************************************
;* Calcula el offset en la FLASH del 876 de la key a utilizar
;* Devuelve en 0x10 el offset de la key y en EEADRH2 la pgina. 
CalcKeyAdr       
				movf	IC_P1,W
				movwf	DUMMY1
				movf	IC_P2,W
				movwf	DUMMY2
				clrf    TEMP+0
            	rrf     DUMMY1,f       	;Pasa los 2 bits bajos del num. de provider a los altos de 0x10
            	rrf     TEMP+0,f       	;Equivalente a desplazar a la izda 6 bits. Esto es porque cada provider ocupa 64 bytes (2^6)
            	rrf     DUMMY1,W       	;W contiene el los bits 1-4 del provider
            	rrf     TEMP+0,f
            	andlw   0x03         	;Se queda con los bits 2-3 del provider
            	movwf   EEADRH2       	;que marcan la pgina (en una pgina (256 bytes) caben 4 providers (4 prov*8 keys*8 bytes/key)
            	bsf     EEADRH2,2    	;Las keys comienzan en 0x0400
            	movlw   0x07         
            	andwf   DUMMY2,f       	;Coge el nmero de la key
CalcKeyAdr_loop       
				movlw   0x08         	;Cada key ocupa 8 bytes
            	decf    DUMMY2,f
            	btfsc   DUMMY2,7      	;Mientras sea positivo, continua el bucle (acaba con el valor -1(0xff))
            	return
            	addwf   TEMP+0,f
            	goto    CalcKeyAdr_loop

;**************************************************************************************************
; Calcula el offset en la eeprom externa de los datos del proveedor especificado en IC_P1
; Devuelve el W el offset y en EEADRH2 la pgina
CalcProvAdr
				clrf	EEADRH2
            	movf    IC_P1,W
            	andlw	0x0F
            	movwf	DUMMY1
            	incf	DUMMY1,F
				movlw   0xF8
CalcProvAdr_loop  
            	addlw   0x18
            	btfsc   STATUS,Z
            	incf    EEADRH2,f
            	decfsz  DUMMY1,f
            	goto    CalcProvAdr_loop
				return
;**************************************************************************************************
; Lee una key de la FLASH del 876. El offset viene en TEMP+0. Se almacena donde indica el registro indirecto
Get_key     
				movf    TEMP+0,W
				call	Rd_Memory
				movwf	INDF
				incf	FSR,f
            	movlw   0x07            ;Leer 8 bytes
            	movwf   TEMP+1             ;0x11 es el contador del bucle
Get_key_loop  
				call    Rd_Memory_Next
            	movwf   INDF
            	incf    FSR,f
            	decfsz  TEMP+1,f
            	goto    Get_key_loop
            	return
;**************************************************************************************************
;Devuelve el valor de Tabla1 del algoritmo de SECA que corresponde al valor contenido en W
Tabla1     	
				clrf	PCLATH
				call	Tabla12
				clrf	PCLATH
				return
Tabla12				
				bcf		PCLATH,0		;Tabla1 en 0x0800
				bsf		PCLATH,3
				movwf   PCL      		;Absolute addressing
;**************************************************************************************************
;Devuelve el valor de Tabla2 del algoritmo de SECA que corresponde al valor contenido en W
Tabla2
				clrf	PCLATH
				call	Tabla22
				clrf	PCLATH
				return
Tabla22				
				bsf		PCLATH,0		;Tabla 2 en 0x0900
				bsf		PCLATH,3
				movwf   PCL      		;Absolute addressing
;**************************************************************************************************
;* FIRMWARE VERSION                                                                               *
;* C1 0A 00 00 44                                                                                 *
;**************************************************************************************************
Instr_0A    
				bsf		CONTROL2,0		;From Card to CAM
				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				movlw	HIGH (I0A_ANS-0x1000)
				movwf	EEADRH2
				movlw   LOW (I0A_ANS-0x1000)
				call    FLASH_send
            	goto    TX90XX
;**************************************************************************************************
;* ENTITLEMENT CONTROL MESSAGE                                                                    *
;* C1 0E 00 00 08                                                                                 *
;**************************************************************************************************
Instr_0E    
				bsf		CONTROL2,0		;From Card to CAM
				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				clrf	EEADRH2
				movlw   0x00   
				call    FLASH_send
            	goto    TX90XX
;**************************************************************************************************
;* REQUEST ID CAM                                                                                 *
;* C1 12 P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_12
				bsf		CONTROL2,0		;From Card to CAM
				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

            	movf	IC_P1,W
            	xorlw	0x0E
            	btfsc	STATUS,Z		;Si se pide Info del Proveedor 14 mostramos
            	goto	ShowMode		;el modo de operacin
            	call	CalcProvAdr
				call    FLASH_send
            	goto    TX90XX
ShowMode
				movlw	0xFF
				call	Send
				movlw	0xFF
				call	Send
				btfss	CONTROL,3		;AutoUpdate ?
				goto	ShowAuto
				movlw	'P'
				call	Send				
				movlw	'R'
				call	Send				
				movlw	'O'
				call	Send				
				movlw	'T'
				call	Send				
				goto	ShowNext1
ShowAuto
				movlw	'A'
				call	Send				
				movlw	'U'
				call	Send				
				movlw	'T'
				call	Send				
				movlw	'O'
				call	Send				
ShowNext1
				movlw	' '
				call	Send
				btfss	CONTROL,6		;Se encontro EEPROM externa
				goto	ShowAccess
				movlw	'N'
				call	Send				
				movlw	'E'
				call	Send				
				movlw	'E'
				call	Send		
				goto	ShowNext2		
ShowAccess								
				btfss	CONTROL,2		;Modo SingleChip?
				goto	ShowInternal
				movlw	'E'
				call	Send				
				movlw	'X'
				call	Send				
				movlw	'T'
				call	Send		
				goto	ShowNext2		
ShowInternal				
				movlw	'I'
				call	Send				
				movlw	'N'
				call	Send				
				movlw	'T'
				call	Send		
ShowNext2				
				movlw	' '
				call	Send
				
				movlw	0x7C					;Leo el contador de datos (LOW)
				call	Rd_eeprom
				movwf	DUMMY1
				movlw	0x7D
				call	Rd_eeprom				;Leo el contador de datos (HIGH)
				movwf	DUMMY2
				
				movf	DUMMY1,W
				btfss	STATUS,Z
				goto	LogCNot0
				movf	DUMMY2,W
				btfss	STATUS,Z
				goto	LogCNot0
				movlw	'E'
				call	Send				
				movlw	'M'
				call	Send				
				movlw	'P'
				call	Send		
				movlw	' '
				call	Send		
				goto	ShowNext3
LogCNot0
				movf	DUMMY1,W
				xorlw	0x04
				btfsc	STATUS,Z
				goto	LogCFull
				movlw	HIGH	Tabla_conv
				movwf	PCLATH
				movf	DUMMY1,W
				andlw	0x0F
				call	Tabla_conv
				call	Send
				movlw	HIGH	Tabla_conv
				movwf	PCLATH
				swapf	DUMMY2,W
				andlw	0x0F
				call	Tabla_conv
				call	Send
				movlw	HIGH	Tabla_conv
				movwf	PCLATH
				movf	DUMMY2,W				
				andlw	0x0F				
				call	Tabla_conv
				call	Send		
				movlw	' '
				call 	Send
				goto	ShowNext3
LogCFull				
				movlw	'F'
				call	Send				
				movlw	'U'
				call	Send				
				movlw	'L'
				call	Send		
				movlw	' '
				call	Send		
ShowNext3
				movlw	'1'
				call	Send
				movlw	'5'
				call	Send
				movlw	' '
				call	Send
				movlw	0x00
				call	Send
				movlw	0x00
				call	Send
				movlw	0x00
				call	Send
				movlw	0x00
				call	Send
				movlw	high DATE
				call	Send
				movlw	low  DATE
				call	Send
				goto	TX90XX            	
;**************************************************************************************************
;* ENTITIES SUPPORTED                                                                             *
;* C1 16 P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_16    
				bsf		CONTROL2,0		;From Card to CAM
				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				clrf	EEADRH2
				movlw   0x08
				movwf	EEADR2
				movlw	0x03
				movwf	DUMMY1
Instr_16_loop
				movf	EEADR2,W			
            	call    Rd_Memory   
            	incf	EEADR2,F
            	decf	DUMMY1,F
            	btfsc	STATUS,Z
            	iorlw	0x40
            	call    Send        
            	decfsz	IC_P3,F
            	goto    Instr_16_loop
		    	goto    TX90XX
;**************************************************************************************************
;*                                                                                                *
;* C1 1A P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_1A    
				bsf		CONTROL2,0		;From Card to CAM
				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				incf	EEADRH2,F		
            	movlw   0xA6
				call    FLASH_send
            	goto    TX90XX
;**************************************************************************************************
;* PIN CONTROLLED OPERATIONS                                                                      *
;* C1 30 P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_30    
				bsf		CONTROL2,1		;From CAM to Card

				call	GetCommandData

				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				movf	IC_P2,W
				btfss	STATUS,Z		;Si P2 <> 0 devuelve 9000
            	goto	TX90XX

				movf	IC_P1,W
				xorlw	0x0F
				btfsc	STATUS,Z
				goto	CheckPassword
            	
            	movlw	0x2E
            	call	Rd_eeprom
				movwf	DUMMY1			;Primer byte del PIN
				movlw	0x2F
				call	Rd_eeprom
            	movwf	DUMMY2			;Segundo byte del PIN
            	
            	movlw	0x0E
            	movwf	FSR2
            	call	Restore
				movwf	DUMMY3			;Primer byte del PIN tecleado            	
            	call	Restore
            	movwf	DUMMY4			;Segundo byte del PIN tecleado

				movf	DUMMY3,F
				btfss	STATUS,Z
				goto	Instr_30_Normal
				movlw	0xF0
				andwf	DUMMY4,W
				btfsc	STATUS,Z
				goto	Instr_30_Special
Instr_30_Normal
            	movlw	0x06
            	movwf	FSR2			;Posicionamos el puntero al byte 6 (PIN almacenado)
            	call	Restore
            	xorwf	DUMMY1,W
            	btfss	STATUS,Z
            	goto	TX9010			;PIN incorrecto
            	call	Restore
            	xorwf	DUMMY2,W
            	btfss	STATUS,Z
            	goto	TX9010			;PIN incorrecto
            	
				movf	DUMMY3,W
            	xorwf	DUMMY1,W
            	btfss	STATUS,Z		;El PIN tecleado es distinto modificar PIN
            	goto	ChangePIN
            	movf	DUMMY4,W
            	xorwf	DUMMY2,W
            	btfss	STATUS,Z		;El PIN tecleado es distinto modificar PIN
            	goto	ChangePIN
   				goto	TX90XX
ChangePIN
				movlw	0x0E
				movwf	FSR2
				movlw	0x2E
				movwf	EEADR2
				call	Restore
				call	Wr_eeprom
				incf	EEADR2,F
				call	Restore
				call	Wr_eeprom
				goto	TX90XX   				
CheckPassword	
				movlw	0x08			;Verificar que el nmero de bytes sea 8
				xorwf	IC_P3,W
				btfss	STATUS,Z
				goto	TX9004
				clrf	FSR2
				movlw	0x08
				movwf	COUNTER			;Longitud 8 bytes
				movlw	0x40
				movwf	EEADR2
CheckPassword_loop
				call	Restore
				movwf	DUMMY1
				movf	EEADR2,W
				call	Rd_eeprom
				incf	EEADR2,F
				xorwf	DUMMY1,W
				btfss	STATUS,Z
				goto	TX9004
				decfsz	COUNTER,F
				goto	CheckPassword_loop
				bsf		CONTROL,0		;Activamos Flag actualizacin
				goto	TX90XX				
;**************************************************************************************************
;* REMOTE CONTROL SPECIAL FUNCTIONS                                                               *
;**************************************************************************************************
Instr_30_Special						
				movlw	0x00
				btfss	CONTROL,1		;Tipo de Led
            	xorlw	0x0F
            	movwf	PORTA
				movlw	0x01
				btfss	CONTROL,1		;Tipo de Led
            	xorlw	0x0F
            	movwf	PORTA						

				movf	DUMMY4,W
				goto	Remote_Table
Remote_00				
				clrf	LEDS
				goto	Instr_30_Normal
Remote_01
				bsf		LEDS,0
				goto	TX9010	
Remote_02				
				bsf		LEDS,1
				goto	TX9010	
Remote_03				
				bsf		LEDS,2
				goto	TX9010	
Remote_04				
				bsf		LEDS,3
				goto	TX9010	
Remote_05				
				movlw	0x00		
				movwf	EEADR2
				call	Rd_eeprom		;Leemos el ConfigByte
				andlw	0xFD			;Desactivamos Bit 1
				call	Wr_eeprom		;Actualizamos el ConfigByte
				bcf		CONTROL,1		;Desactivamos Bit 1
				goto	TX9010	
Remote_06				
				movlw	0x00		
				movwf	EEADR2
				call	Rd_eeprom		;Leemos el ConfigByte
				iorlw	0x02			;Activamos Bit 1
				call	Wr_eeprom		;Actualizamos el ConfigByte
				bsf		CONTROL,1		;Activamos Bit 1
				goto	TX9010	
Remote_07				
				movlw	0x00		
				movwf	EEADR2
				call	Rd_eeprom		;Leemos el ConfigByte
				iorlw	0x08			;Activamos Bit 3
				call	Wr_eeprom		;Actualizamos el ConfigByte
				bsf		CONTROL,3		;Activamos Bit 3
				goto	TX9010	
Remote_08				
				movlw	0x00		
				movwf	EEADR2
				call	Rd_eeprom		;Leemos el ConfigByte
				andlw	0xF7			;Desactivamos Bit 3
				call	Wr_eeprom		;Actualizamos el ConfigByte
				bcf		CONTROL,3		;Desactivamos Bit 3
				goto	TX9010	
Remote_09				
				movlw	0x00		
				movwf	EEADR2
				call	Rd_eeprom		;Leemos el ConfigByte
				iorlw	0x04			;Activamos Bit 2
				call	Wr_eeprom		;Actualizamos el ConfigByte
				bsf		CONTROL,2		;Activamos Bit 2
				goto	TX9010	
Remote_10				
				movlw	0x00		
				movwf	EEADR2
				call	Rd_eeprom		;Leemos el ConfigByte
				andlw	0xFB			;Desactivamos Bit 2
				call	Wr_eeprom		;Actualizamos el ConfigByte
				bcf		CONTROL,2		;Desactivamos Bit 2
				goto	TX9010	
Remote_11		
				movlw	0x90
				call	Send            	
				movlw	0x10
				call	Send

				btfsc	CONTROL,6		;Si no hay EEPROM externa
				goto	Main			;No hacer nada
		
				movlw	0x10
				movwf	COUNTER
				clrf	EEADR2			;Preparamos punteros para Wr_ExtMem
				clrf	EEADRH2
										;Preparamos punteros para Rd_Flash
				bsf		STATUS,RP1		;Select Bank 2
				clrf	EEADR
				movlw	0x10			;Mapearlo en el segundo 4K bloque
				movwf   EEADRH
				bcf		STATUS,RP1		;Select Bank 0
				
Remote_11_loop0				
				movlw	0x01
				movwf	LEDS
Remote_11_loop1				
				clrf	DUMMY1
            	movf	LEDS,W
				btfss	CONTROL,1		;Tipo de Led
            	xorlw	0x0F
            	movwf	PORTA
            	rlf		LEDS,F
            	btfsc	LEDS,5
            	goto	Remote_11_loop0
            	
Remote_11_loop2
				call	Rd_Flash_Next
				call	Wr_ExtMem2
				incf	EEADR2,F
				btfsc	STATUS,Z
				incf	EEADRH2,F
				decfsz	DUMMY1,F
				goto	Remote_11_loop2
				decfsz	COUNTER,F
				goto	Remote_11_loop1			
				clrf	LEDS
				goto	Main
Remote_12
				movlw	0x90
				call	Send            	
				movlw	0x10
				call	Send
		
				btfsc	CONTROL,6		;Si no hay EEPROM externa
				goto	Main			;No hacer nada

				movlw	0x10
				movwf	COUNTER
				clrf	EEADR2			;Preparamos punteros
				clrf	EEADRH2
			
Remote_12_loop0				
				movlw	0x01
				movwf	LEDS
Remote_12_loop1				
				clrf	DUMMY1
            	movf	LEDS,W
				btfss	CONTROL,1		;Tipo de Led
            	xorlw	0x0F
            	movwf	PORTA
            	rlf		LEDS,F
            	btfsc	LEDS,5
            	goto	Remote_12_loop0
            	
Remote_12_loop2
				call	Rd_ExtMem2
				call	Wr_Flash
				incf	EEADR2,F
				btfsc	STATUS,Z
				incf	EEADRH2,F
				decfsz	DUMMY1,F
				goto	Remote_12_loop2
				decfsz	COUNTER,F
				goto	Remote_12_loop1			
				clrf	LEDS
				goto	Main

Remote_13				
				;Activacion captura de comandos
				movlw	0x00		
				movwf	EEADR2
				call	Rd_eeprom		;Leemos el ConfigByte
				iorlw	0x10			;Activamos Bit 1
				call	Wr_eeprom		;Actualizamos el ConfigByte
				bsf		CONTROL,4		;Activamos Bit 1

				goto	TX9010	

Remote_14				
				;Desactivacion captura de comandos
				movlw	0x00		
				movwf	EEADR2
				call	Rd_eeprom		;Leemos el ConfigByte
				andlw	0xEF			;Desactivamos Bit 3
				call	Wr_eeprom		;Actualizamos el ConfigByte
				bcf		CONTROL,4		;Desactivamos Bit 3
				goto	TX9010	
Remote_15				
				;Borrado log
				;Borro el contador
				movlw	0x7C
				movwf	EEADR2
				movlw	0x00
				call	Wr_eeprom
				incf	EEADR2,F
				movlw	0x00
				call	Wr_eeprom

				;Borro el log

				movlw	0x0C
				movwf	EEADRH2
				movlw	0x00
				movwf	EEADR2

Remote_15_Loop
				movlw	0x00
				call	Wr_Memory
				incf	EEADR2,F
				btfss	STATUS,Z
				goto	Remote_15_Loop
				incf	EEADRH2,F
				btfss	EEADRH2,4		;El buffer est lleno
				goto	Remote_15_Loop

				goto	TX9010	
;**************************************************************************************************
;* READ REQUESTED INFORMATION                                                                     *
;* C1 32 P1 00 LEN                                                                                *
;**************************************************************************************************
Instr_32    
				bsf		CONTROL2,0		;From Card to CAM
				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				incf	EEADRH2,F
            	movlw   0x99       		;Startup record en 0x199      
            	btfss   F40,0      		;Comprueba que se pidi el startup record (ultimo byte impar)
            	goto    SendInfo      	;Si es par salta porque supone que es el comando de extra y general infos 
				call    FLASH_send
            	goto    TX90XX
;**************************************************************************************************
;* REQUEST INFORMATION                                                                            *
;* C1 34 00 00 03                                                                                 *
;**************************************************************************************************
Instr_34    
				call    Receive        	
            	decfsz  IC_P3,f
            	goto    Instr_34
            	movwf   F40        		;Almacena ultimo byte recibido en 0x40

				bsf		CONTROL2,0		;From Card to CAM
				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

            	goto    TX90XX      	;9000

;**************************************************************************************************
;* REQUEST CONTROL WORDS                                                                          *
;* C1 3A 00 00 10                                                                                 *
;**************************************************************************************************
Instr_3A    
				bsf		CONTROL2,0		;From Card to CAM

				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				bcf		LEDS,0			;Desactivamos el led 0
				movlw   BUFFER
            	movwf   FSR
Instr_3A_loop  
            	movf    INDF,W      
            	call    Send        
            	incf    FSR,f       
            	decfsz  IC_P3,f
            	goto    Instr_3A_loop
            	goto    TX90XX      
;**************************************************************************************************
;* ENTITLEMENT CONTROL MESSAGE                                                                    *
;* C1 3C P1 P2 LEN                                                                                *
;**************************************************************************************************
;* Esta instruccin envia control words encriptados para que se desencripten                      *
;**************************************************************************************************
Instr_3C    
				bcf		CONTROL2,0		;From CAM to Card
				bsf		LEDS,0
				call	GetCommandData

				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				call	Decode
				call	CheckSignature
				xorlw	0x00
				btfss	STATUS,Z
				goto	TX9002			;Clave Falsa o Firma Inexistente

				bcf		CONTROL2,3
				call	ProcessNano
				
				btfss	CONTROL2,3
				goto	TX9302			;No se han encontrado las CW

				goto    TX90XX
;**************************************************************************************************
;* ENTITLEMENT MANAGEMENT                                                                         *
;* C1 40 P1 P2 LEN                                                                                *
;**************************************************************************************************
Instr_40    
				bcf		CONTROL2,0		;From CAM to Card
				call	GetCommandData

				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

            	movf    IC_P1,W         ;Coge P1
            	andlw   0x0F            ;Si es el provider 0 (SECA) sale
            	btfsc   STATUS,Z        ;Skip if not zero
            	goto    TX90XX
          	
				call	Decode
				call	CheckSignature
				xorlw	0x00
				btfss	STATUS,Z
				goto	TX9002			;Clave Falsa o Firma Inexistente

				bsf		LEDS,0			;Activamos LED1

				call	ProcessNano
				goto	TX90XX
;**************************************************************************************************
;Actualiza la fecha de suscripcin
UpdateDate
            	call	CalcProvAdr
            	addlw	0x16			;Offset de la fecha
            	movwf   DUMMY2
            	
            	call	Restore
            	movwf	DUMMY3
            	call	Restore
            	movwf	DUMMY4
				movf	DUMMY2,W
            	call    Rd_Memory        ;\Lee byte de fecha
            	xorwf	DUMMY3,W
            	btfss   STATUS,Z        ; Si es igual no lo escribe
            	goto    UpdateDate_wr	; Si es diferente: actualizar
            	call    Rd_Memory_Next   ;\lee segundo byte de fecha
            	xorwf   DUMMY4,W        ;/
            	btfsc   STATUS,Z        ; Y mira si ha cambiado
            	return          		; sino ha cambiado, sale
UpdateDate_wr
            	btfsc	CONTROL,3		;No realizar si la proteccin de actualizaciones est activada
            	return
				bsf		LEDS,3			;Activa el LED 3

				movf    DUMMY2,W        ;Escribe los dos bytes de la fecha en la EEPROM
				movwf	EEADR2
            	movf    DUMMY3,W
            	call    Wr_Memory
            	incf	EEADR2,F
            	movf    DUMMY4,W
            	call    Wr_Memory
            	return
;**************************************************************************************************
;Actualiza la clave primaria
UpdatePKey
				call	Restore
				movwf	IC_P2
				call	LoadBuffer
				call	Decrypt
            	call    CalcKeyAdr      ;Offset de la key en EEPROM externa
            	movf    TEMP+0,W
            	movwf	DUMMY2

				movlw	BUFFER
				movwf	FSR
UpdatePKey_loop 
				movf	DUMMY2,W
				call	Rd_Memory
            	xorwf   INDF,W
            	btfss   STATUS,Z        ;Skip if zero
            	goto    UpdatePKey_wr    ;Si es diferente: Actualizar clave
            	incf	DUMMY2,F
            	incf	FSR,F
            	btfss	FSR,3
            	goto    UpdatePKey_loop
            	return
UpdatePKey_wr
            	btfsc	CONTROL,3		;No realizar si la proteccin de actualizaciones est activada
            	return
				bsf		LEDS,3			;Activa el LED 3

				movlw	BUFFER
				movwf	FSR
            	movlw   0x08            ;\ length
            	movwf   COUNTER         ;/
				movf    TEMP+0,W           ;Actualiza una clave
				movwf	EEADR2
UpdatePKey_wrloop				
				movf	INDF,W
				call	Wr_Memory
				incf	EEADR2,F
				incf	FSR,F
				decfsz	COUNTER,F
				goto	UpdatePKey_wrloop
            	return
;**************************************************************************************************
;Actualiza la clave secundaria
UpdateSKey
				call	Restore
				movwf	IC_P2
				call	LoadBuffer
				call	Decrypt
            	call    CalcKeyAdr      ;Offset de la key en EEPROM externa
            	movlw	0x04
            	addwf	EEADRH2,F		;Offset de la keys secundarias en 0x1800
            	movf    TEMP+0,W
            	movwf	DUMMY2

				movlw	BUFFER
				movwf	FSR
UpdateSKey_loop 
				movf	DUMMY2,W
				call	Rd_Memory
            	xorwf   INDF,W
            	btfss   STATUS,Z        ;Skip if zero
            	goto    UpdateSKey_wr    ;Si es diferente: Actualizar clave
            	incf	DUMMY2,F
            	incf	FSR,f
            	btfss	FSR,3
            	goto    UpdateSKey_loop
            	return
UpdateSKey_wr
            	btfsc	CONTROL,3		;No realizar si la proteccin de actualizaciones est activada
            	return
				bsf		LEDS,3			;Activa el LED 3

				movlw	BUFFER
				movwf	FSR
            	movlw   0x08            ;\ length
            	movwf   COUNTER         ;/
				movf    TEMP+0,W           ;Actualiza una clave
				movwf	EEADR2
UpdateSKey_wrloop
				movf	INDF,W
				call	Wr_Memory
				incf	EEADR2,F
				incf	FSR,F
				decfsz	COUNTER,F
				goto	UpdateSKey_wrloop
            	return
;**************************************************************************************************
;* C1 5A P1 P2 LEN                                                                                *
;**************************************************************************************************
;* Devuelve una cadena de FFs. Comprueba una mscara contenida en la EEPROM del pic y segun eso  *
;* devuelve 9000 0 901D																			  *
;**************************************************************************************************
Instr_5A    
				bsf		CONTROL2,0		;From Card to CAM

				btfsc   CONTROL,4		;Log activo?
				call    Log				;Capturo

				incf    IC_P2,f
            	movf    IC_P1,W
            	addlw   0x30
            	call    Rd_eeprom
            	andwf   IC_P2,W
            	btfss   STATUS,Z
            	bsf     CONTROL,7         ;Devolver 901D (error)
            	movlw   0xFF              ;Devolver cadena de FF
            	goto    SendInfo_loop
;**************************************************************************************************
SendInfo       
				movf    IC_P1,f
            	btfsc   STATUS,Z        ;Si es el provider 0 slo devuelve el nano 04
            	goto    SendInfo_end
            	movlw   0x83            ;nano 83: sigue un package bitmap
            	call    Send
            	decf    TEMP+0,f          	;1 byte enviado
            	movlw   0x08            ;Almacena 0x08 en 0x0f
            	movwf   IC_P3
            	subwf   TEMP+0,f          	;quita 8 bytes por enviar (el bitmap)
            	bcf     STATUS,C
            	rlf     IC_P1,f
            	rlf     IC_P1,f
            	rlf     IC_P1,W         ;W=Provider*8  
            	incf    EEADRH2,f      	;Estn a aprtir de 0x1200 y ocupan 8 bytes cada uno
            	call    FLASH_send     ;Enva el bitmap  
SendInfo_end    
				movlw   0x04            ;Envia 04 y completa  con FF la longitud solicitada

;Enva el byte contenido en W y a continuacin una cadena de 0xFF. La longitud viene en 0x10
SendInfo_loop  
				call    Send
            	movlw   0xFF
            	decfsz  TEMP+0,f
            	goto    SendInfo_loop
            	goto    TX90XX
;**************************************************************************************************
;Lee un bloque de datos de la FLASH del 876 si P1 = 21h lee de la eeprom
Instr_20    
				btfss	CONTROL,0		;Comprobar Flag de Actualizacin
				goto	TX6D00
				movf	IC_P1,W
				xorlw	0x21
				btfsc	STATUS,Z
				goto	Instr_20E
				movf    IC_P1,W       	;P1: Parte alta de la direccin a leer
				movwf	EEADRH2
            	movf    IC_P2,W       	;P2: Parte baja
            	movwf	EEADR2
instr_20_loop  
				movf	EEADR2,W
            	call    Rd_Memory      	;Lee valor de la Flash del 876
            	call    Send         	;Y lo enva  
            	incf	EEADR2,F
            	btfsc	STATUS,Z
            	incf	EEADRH2,F
            	decfsz  IC_P3,f      
            	goto    instr_20_loop
            	goto    TX90XX
Instr_20E
				movf	IC_P2,W
				call	Rd_eeprom
				call	Send
				incf	IC_P2,F
				decfsz	IC_P3,F
				goto	Instr_20E
				goto	TX90XX
;**************************************************************************************************
;* Escribe un bloque de datos en la FLASH del 876 si P1 = 21h escribe en la eeprom
Instr_22    
				btfss	CONTROL,0		;Comprobar Flag de Actualizacin
				goto	TX6D00
				call	GetCommandData
            	clrf    FSR2
				movf	IC_P2,W
				movwf	EEADR2
				movf	IC_P1,W
				xorlw	0x21
				btfsc	STATUS,Z
				goto	Instr_22E
				movf	IC_P1,W
				movwf	EEADRH2
instr_22_loop  
            	call    Restore            ;Recibe un byte
            	call	Wr_Memory
            	incf	EEADR2,F
            	btfsc	STATUS,Z
            	incf	EEADRH2,F
				decfsz	IC_P3,F
				goto	instr_22_loop
            	goto    TX90XX
Instr_22E
				call	Restore
				call	Wr_eeprom	
				incf	EEADR2,F
				decfsz	IC_P3,F
				goto	Instr_22E
				goto	TX90XX
;**************************************************************************************************
;* Leer la Flash de Programa 	
;* P1:P2 	Direccion
;* P3		Longitud
;**************************************************************************************************
Instr_24    
				btfss	CONTROL,0		;Comprobar Flag de Actualizacin
				goto	TX6D00
				movf    IC_P1,W       	;P1: Parte alta de la direccin a leer
				movwf	EEADRH2
            	movf    IC_P2,W       	;P2: Parte baja
            	movwf	EEADR2
            	rrf		IC_P3,F
instr_24_loop  
            	call    Rd_PFlash      	;Lee valor de la Flash del 876
            	bsf		STATUS,RP1		;Select Bank 2
            	movf	EEDATH,W
            	bcf		STATUS,RP1		;Back to Bank 0
            	call    Send         	;Y lo enva  
            	bsf		STATUS,RP1		;Select Bank 2
            	movf	EEDATA,W
            	bcf		STATUS,RP1		;Back to Bank 0
            	call    Send         	;Y lo enva  
            	incf	EEADR2,F
            	btfsc	STATUS,Z
            	incf	EEADRH2,F
            	decfsz  IC_P3,f      
            	goto    instr_24_loop
            	goto    TX90XX

;**************************************************************************************************
;* Escribir en la Flash de Programa
;* P1:P2 	Direccion
;* P3		Longitud
;**************************************************************************************************
Instr_26
				btfss	CONTROL,0		;Comprobar Flag de Actualizacin
				goto	TX6D00
				call	GetCommandData
				movf	IC_P1,W
				movwf	EEADRH2
				movf	IC_P2,W
				movwf	EEADR2
            	clrf    FSR2
            	rrf		IC_P3,F
instr_26_loop  
            	call    Restore         ;Recibe un byte
            	bsf		STATUS,RP1		;Select Bank 2
            	movwf	EEDATH
            	bcf		STATUS,RP1		;Back to Bank 0
            	call    Restore         ;Recibe un byte
            	bsf		STATUS,RP1		;Select Bank 2
            	movwf	EEDATA
            	bcf		STATUS,RP1		;Back to Bank 0
            	call	Wr_PFlash
            	incf	EEADR2,F
            	btfsc	STATUS,Z
            	incf	EEADRH2,F
				decfsz	IC_P3,F
				goto	instr_26_loop
            	goto    TX90XX
;**************************************************************************************************
;* Ejecutar el cdigo de la Flash de Programa
;* P1:P2 	Direccion
;**************************************************************************************************
Instr_28
				btfss	CONTROL,0		;Comprobar Flag de Actualizacin
				goto	TX6D00
				call	Instr_28_Exec
				clrf	PCLATH
				goto	TX90XX
Instr_28_Exec				
				movf	IC_P1,W
				movwf	PCLATH
				movf	IC_P2,W
				movwf	PCL

;**************************************************************************************************
;* STORE W->[FSR2] 256                                                                            *
;**************************************************************************************************
Store
				movwf	0x7F
				movf	FSR,W
				movwf	0x7E
				movlw	0x50
				subwf	FSR2,W
				btfss	STATUS,C
				goto	Store_1
				movlw	0xB0
				subwf	FSR2,W
				btfss	STATUS,C
				goto	Store_2
Store_3
				movlw	0xE0
				addwf	FSR2,W
				movwf	FSR
				bsf		STATUS,IRP
				movf	0x7F,W
				movwf	INDF
				bcf		STATUS,IRP
				incf	FSR2,F
				movf	0x7E,W
				movwf	FSR
				movf	0x7F,W
				return
Store_2
				movlw	0xC0
				addwf	FSR2,W
				movwf	FSR
				bsf		STATUS,IRP
				movf	0x7F,W
				movwf	INDF
				bcf		STATUS,IRP
				incf	FSR2,F
				movf	0x7E,W
				movwf	FSR
				movf	0x7F,W
				return
Store_1				
				movlw	0xA0
				addwf	FSR2,W
				movwf	FSR
				movf	0x7F,W
				movwf	INDF
				bcf		STATUS,IRP
				incf	FSR2,F
				movf	0x7E,W
				movwf	FSR
				movf	0x7F,W
				return
;**************************************************************************************************
;* RESTORE [FSR2]->W 256                                                                          *
;**************************************************************************************************
Restore
				movf	FSR,W
				movwf	0x7E
				movlw	0x50
				subwf	FSR2,W
				btfss	STATUS,C
				goto	Restore_1
				movlw	0xB0
				subwf	FSR2,W
				btfss	STATUS,C
				goto	Restore_2
Restore_3
				movlw	0xE0
				addwf	FSR2,W
				movwf	FSR
				bsf		STATUS,IRP
				movf	INDF,W
				movwf	0x7F
				bcf		STATUS,IRP
				incf	FSR2,F
				movf	0x7E,W
				movwf	FSR
				movf	0x7F,W
				return
Restore_2
				movlw	0xC0
				addwf	FSR2,W
				movwf	FSR
				bsf		STATUS,IRP
				movf	INDF,W
				movwf	0x7F
				bcf		STATUS,IRP
				incf	FSR2,F
				movf	0x7E,W
				movwf	FSR
				movf	0x7F,W
				return
Restore_1				
				movlw	0xA0
				addwf	FSR2,W
				movwf	FSR
				bcf		STATUS,IRP
				movf	INDF,W
				movwf	0x7F
				incf	FSR2,F
				movf	0x7E,W
				movwf	FSR
				movf	0x7F,W
				return
;**************************************************************************************************
;* GET COMMAND HEADER                                                                             *
;**************************************************************************************************
GetCommandHeader
            	movlw   IC_CLA
            	movwf   FSR
Com_loop    
				call    Receive
            	movwf   INDF
            	movwf   TEMP+0        		;TEMP+0 contiene el ultimo byte leido (al salir la longitud)
            	incf    FSR,f
            	btfsc   FSR,3
            	goto    Com_loop
				return
;**************************************************************************************************
;* GET COMMAND DATA                                                                               *
;**************************************************************************************************
GetCommandData
				clrf	FSR2
				movf	IC_P3,W
				movwf	COUNTER
GetCmdData_loop	
				call	Receive
				call	Store
				decfsz	COUNTER,f
				goto	GetCmdData_loop
				return
;**************************************************************************************************
;* CHECK SIGNATURE                                                                                *
;**************************************************************************************************
CheckSignature
				movlw	0x08
				subwf	IC_P3,W			;Ajusta el numero de bytes que entran en la computacin
				movwf	COUNTER
				movwf	FSR2			;Comprueba que el comando contenga el nano 82 de la
				decf	FSR2,F			;firma 9 posiciones antes del final
				call	Restore
				xorlw	0x82
				btfss	STATUS,Z		
				retlw	0x01			;Devuelve error (No hay firma)
				call	InitHashBuf		;Inicializa el Hash Buffer
				clrf	FSR2
CheckSign_loop				
				call	XorBuffer
				call	LoadKeys
				call	Encrypt
				movf	COUNTER,F
				btfss	STATUS,Z
				goto	CheckSign_loop

				bsf		LEDS,1			;Activamos LED2 Clave Falsa

				movlw	BUFFER
				movwf	FSR
				movlw	0x08
				movwf	COUNTER
CheckSign_loop2
				call	Restore
				xorwf	INDF,W
				btfss	STATUS,Z
				retlw	0x02
				incf	FSR,F
				decfsz	COUNTER,F
				goto	CheckSign_loop2
				call	LoadKeys		
				bcf		LEDS,1			;Desactivamos LED2 Clave Falsa
				retlw	0x00
XorBuffer
				movlw	BUFFER
				movwf	FSR
XorBuffer_loop
				call	Restore
				xorwf	INDF,F
				decf	COUNTER,F
				btfsc	STATUS,Z
				return
				incf	FSR,F
				btfss	FSR,3			;CUIDADO!!!
				goto	XorBuffer_loop
				return
InitHashBuf
				movlw	0x00			;Inicializa Hash Buffer a ceros
				movwf	BUFFER
				movwf	BUFFER+1
				movwf	BUFFER+2
				movwf	BUFFER+3
				movwf	BUFFER+4
				movwf	BUFFER+5
				movwf	BUFFER+6
				movwf	BUFFER+7

				movf	IC_P1,W
				andlw	0xE0
				movwf	DUMMY1
				xorlw	0x20
				btfsc	STATUS,Z
				goto	InitHashBuf1
				movf	DUMMY1,W
				xorlw	0x40
				btfsc	STATUS,Z
				goto	InitHashBuf2
				movf	DUMMY1,W
				xorlw	0x60
				btfsc	STATUS,Z
				goto	InitHashBuf3
InitHashBuf0							;Hash Buffer a ceros				
				return
InitHashBuf1							;Inicializa Hash Buffer a UA,0,0
				clrf	EEADRH2
				movlw	2
				call	Rd_Memory
				movwf	BUFFER+0
				call	Rd_Memory_Next
				movwf	BUFFER+1
				call	Rd_Memory_Next
				movwf	BUFFER+2
				call	Rd_Memory_Next
				movwf	BUFFER+3
				call	Rd_Memory_Next
				movwf	BUFFER+4
				call	Rd_Memory_Next
				movwf	BUFFER+5
				return
InitHashBuf2							;Inicializa Hash Buffer a PPUA,0,0,0,0
				call	CalcProvAdr		;Offset Provider Info
            	addlw	0x12			;Offset PPUA
            	call	Rd_Memory
				movwf	BUFFER+0
				call	Rd_Memory_Next
				movwf	BUFFER+1
				call	Rd_Memory_Next
				movwf	BUFFER+2
				call	Rd_Memory_Next
				movwf	BUFFER+3
				return
InitHashBuf3							;Inicializa Hash Buffer a SA,0,0,0,0,0					
				call	CalcProvAdr
				addlw	0x12
				call	Rd_Memory
				movwf	BUFFER+0
				call	Rd_Memory_Next
				movwf	BUFFER+1
				call	Rd_Memory_Next
				movwf	BUFFER+2
				return
;**************************************************************************************************
;* LOAD KEYS                                                                                      *
;**************************************************************************************************
LoadKeys      
            	call    CalcKeyAdr
            	movlw   PK        
            	movwf   FSR       
            	call    Get_key			;Carga la PK
            	movlw   0x04
            	btfsc   IC_P1,4   		;Si se utiliza PK+SK apuntar a SK
            	addwf   EEADRH2,F
            	call    Get_key   		;Carga la SK
				return                
;**************************************************************************************************
;* DECODE DATA IN SUPERENCRIPTION                                                                 *
;**************************************************************************************************
Decode
      			btfss  	IC_P2,7			;Hay Supercriptacin?
            	return					;Si NO -> volver
				call	LoadKeys
				clrf	FSR2
				decf	IC_P3,W
				andlw	0xF8
				movwf	COUNTER
Decode_loop	
				movf	COUNTER,F
				btfsc	STATUS,Z
				return          
				call	LoadBuffer
				call	Decrypt
				movlw	0x08	
				subwf	FSR2,F		
				subwf	COUNTER,F
				call	StoreBuffer
				goto	Decode_loop				      
;**************************************************************************************************
;* PROCESS NANO                                                                                   *
;**************************************************************************************************
ProcessNano
				clrf	FSR2
ProcessNano_loop				
				movf	FSR2,W
				subwf	IC_P3,W
				btfsc	STATUS,Z
				return
				call	Restore			;Leemos Nano
				movwf	DUMMY1
				
				xorlw	(0x12 ^ 0x00)
				btfsc	STATUS,Z
				goto	Nano12			;Nano 12 (Control Parental)

				xorlw	(0x21 ^ 0x12)
				btfsc	STATUS,Z
				goto	Nano21			;Nano 21 (Fecha fin de abono)

				xorlw	(0x41 ^ 0x21)
				btfsc	STATUS,Z
				goto	Nano41			;Nano 41 (Nueva PPUA)

				xorlw	(0x90 ^ 0x41)
				btfsc	STATUS,Z
				goto	Nano90			;Nano 90 (Nueva PK)

				xorlw	(0x91 ^ 0x90)
				btfsc	STATUS,Z
				goto	Nano91			;Nano 91 (Nueva SK)

				xorlw	(0xD0 ^ 0x91)
				btfsc	STATUS,Z
				goto	NanoD0			;Nano D0 (Nuevo Provider ID string)

				xorlw	(0xF0 ^ 0xD0)
				btfsc	STATUS,Z
				goto	NanoF0			;Nano F0 (CUSTWP-Bitmap)

				xorlw	(0xD1 ^ 0xF0)
				btfsc	STATUS,Z
				goto	NanoD1

                xorlw   (0x80 ^ 0xD1)	;*RASMA*
                btfsc   STATUS,Z		;*RASMA*
                goto    Nano80          ;*RASMA* Nano 80 (Nuevo PBM)


ProcessNano_done				
				swapf	DUMMY1,W
				andlw	0x0F
				movwf	DUMMY1
				movlw	0x0D
				xorwf	DUMMY1,W
				btfsc	STATUS,Z
				goto	ProcessNano_DX
				movlw	0x0E
				xorwf	DUMMY1,W
				btfsc	STATUS,Z
				goto	ProcessNano_EX
				movlw	0x0F
				xorwf	DUMMY1,W
				btfsc	STATUS,Z
				goto	ProcessNano_FX
				movf	DUMMY1,W
ProcessNano_next
				addwf	FSR2,F
				goto	ProcessNano_loop
ProcessNano_DX
				movlw	0x10
				goto	ProcessNano_next				
ProcessNano_EX
				movlw	0x18
				goto	ProcessNano_next				
ProcessNano_FX
				movlw	0x20
				goto	ProcessNano_next				
;**************************************************************************************************
Nano12									;Control Parental
				goto	ProcessNano_done
;**************************************************************************************************
Nano21
				call	UpdateDate
				goto	ProcessNano_loop
;**************************************************************************************************
Nano41									;Cambiar la PPUA del proveedor
            	call 	CalcProvAdr
            	addlw	0x12			;Offset de la PPUA
            	movwf	EEADR2
				call	Restore
				call	Wr_Memory
				incf	EEADR2,F
				call	Restore
				call	Wr_Memory
				incf	EEADR2,F
				call	Restore
				call	Wr_Memory
				incf	EEADR2,F
				call	Restore
				call	Wr_Memory
				goto	ProcessNano_loop
;**************************************************************************************************
Nano90
				call	UpdatePKey
				goto	ProcessNano_loop
;**************************************************************************************************
Nano91
				call	UpdateSKey
				goto	ProcessNano_loop
;**************************************************************************************************
NanoD0									;Cambia el ID string del proveedor
            	call 	CalcProvAdr
            	addlw	0x02			;Offset de ID string
            	movwf	EEADR2
				call	LoadBuffer
				call    xor_F8_30     	;Swap de 0x30-0x37 con 0x38-0x3f
				call	LoadBuffer
				call    xor_F8_30     	;Swap de 0x30-0x37 con 0x38-0x3f
				movlw	0x10
				movwf	COUNTER
				movlw	BUFFER
				movwf	FSR
NanoD0_loop				
				movf	INDF,W
				call	Wr_Memory
				incf	EEADR2,F
				incf	FSR,F
				decfsz	COUNTER,F
				goto	NanoD0_loop
				goto	ProcessNano_loop

;**************************************************************************************************
NanoD1				
				call	LoadKeys
				call	LoadBuffer
				call	Decrypt
				call    xor_F8_30     	;Swap de 0x30-0x37 con 0x38-0x3f
				call	LoadBuffer
			   	call    Decrypt     
				call    xor_F8_30     	;Swap de 0x30-0x37 con 0x38-0x3f
				bsf		CONTROL2,3
				goto	ProcessNano_loop
;**************************************************************************************************
NanoF0
				movf	FSR2,W
				addlw	0x20
				movwf	DUMMY3			
				call	CalcProvAdr
				addlw	0x15
				call	Rd_Memory		;Leemos el ltimo byte de la PPUA
				movwf	DUMMY1
				xorlw   0x00            ;RASMA 21/01/01
                btfsc   STATUS, Z       ;RASMA 21/01/01
                goto    IgnoraNanoF0    ;RASMA 21/01/01 Si el ultimo byte de la ppua es 0 no le hacemos caso	
				andlw	0x07
				movwf	COUNTER			;Alcanenamos el Offset del byte
				rrf		DUMMY1,F
				rrf		DUMMY1,F
				rrf		DUMMY1,W
				andlw	0x1F
				sublw	0x1F
				addwf	FSR2,F				
				call	Restore				
				movwf	DUMMY1
				incf	COUNTER,F
NanoF0_loop				
				rrf		DUMMY1,F
				decfsz	COUNTER,F
				goto	NanoF0_loop
				btfss	STATUS,C
				goto	TX9009			;Si la tarjeta no est direccionada devolver 9009
				
				movf	DUMMY3,W
				movwf	FSR2
				goto	ProcessNano_loop

IgnoraNanoF0	movf	DUMMY3,W
				movwf	FSR2
				goto	ProcessNano_loop

;*RASMA***************************************************************************************************
Nano80
                movlw   0x08
                movwf   COUNTER ; inicializo el contador
                movf    IC_P1, W
                movwf   EEADR2
                rlf     EEADR2
                rlf     EEADR2
                rlf     EEADR2  ; multiplico por 8 el proveedor
                movlw   0x02    ; Direccion de comienzo de las PBM
                movwf   EEADRH2

Nano80_loop
                call    Restore
                call    Wr_Memory
                incf	EEADR2
                decfsz  COUNTER
                goto    Nano80_loop
                goto    ProcessNano_loop

;**************************************************************************************************
;* SEARCH NANO                                                                                    *
;**************************************************************************************************
SearchNano
				clrf	FSR2
SearchNanoNext			
				movwf	DUMMY1
SearchNano_loop				
				movf	FSR2,W
				subwf	IC_P3,W
				btfsc	STATUS,Z
				retlw	0x01
				call	Restore
				movwf	DUMMY2
				xorwf	DUMMY1,W
				btfsc	STATUS,Z
				retlw	0x00			;Se ha encontrado el nano
				swapf	DUMMY2,W
				andlw	0x0F
				movwf	DUMMY2
				movlw	0x0D
				xorwf	DUMMY2,W
				btfsc	STATUS,Z
				goto	SearchNano_DX
				movlw	0x0E
				xorwf	DUMMY2,W
				btfsc	STATUS,Z
				goto	SearchNano_EX
				movlw	0x0F
				xorwf	DUMMY2,W
				btfsc	STATUS,Z
				goto	SearchNano_FX
				movf	DUMMY2,W
SearchNano_next
				addwf	FSR2,F
				goto	SearchNano_loop
SearchNano_DX
				movlw	0x10
				goto	SearchNano_next				
SearchNano_EX
				movlw	0x18
				goto	SearchNano_next				
SearchNano_FX
				movlw	0x20
				goto	SearchNano_next				
;**************************************************************************************************
;* READ MEMORY FLASH/EXTERNAL                                                                     *
;**************************************************************************************************
;* EEADRH2:W = Address of Memory                                                                  *
;* W = Data Read                                                                                  *
;**************************************************************************************************
Rd_Memory		
				btfss	CONTROL,2
				goto	Rd_Flash
				goto	Rd_ExtMem
Rd_Memory_Next
				btfss	CONTROL,2
				goto	Rd_Flash_Next
				goto	Rd_ExtMem_Next
;**************************************************************************************************
;* WRITE MEMORY FLASH/EXTERNAL                                                                    *
;**************************************************************************************************
;* EEADRH2:EEADR2 = Address of Memory                                                             *
;* W = Data Written                                                                               *
;**************************************************************************************************
Wr_Memory		
				btfss	CONTROL,2
				goto	Wr_Flash
				goto	Wr_ExtMem
;**************************************************************************************************
;* READ FLASH MEMORY                                                                              *
;**************************************************************************************************
;* EEADRH2:W = Address of Memory                                                                  *
;* W = Data Read                                                                                  *
;**************************************************************************************************
Rd_Flash
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEADR
				bcf		STATUS,RP1		;Select Bank 0
				movf	EEADRH2,W
				addlw	0x10			;Mapearlo en el segundo 4K bloque
				bsf		STATUS,RP1		;Select Bank 2
				movwf   EEADRH
Rd_Flash_Next
				bsf		STATUS,RP1		
            	bsf     STATUS,RP0      ;Select Bank 3
            	bsf		EECON1,EEPGD
            	bsf     EECON1,RD
            	nop						;Any instructions here are ignored as program
            	nop						;memory is read in third cycle after BSF EECON1,RD
            	bcf     STATUS,RP0      ;Select Bank 2
            	movf    EEDATA,W
            	incf	EEADR,F
            	btfsc	STATUS,Z
            	incf	EEADRH,F
            	bcf		STATUS,RP1		;Select Bank 0				
				return
;**************************************************************************************************
;* WRITE FLASH MEMORY                                                                             *
;**************************************************************************************************
;* EEADRH2:EEADR2 = Address of Flash Memory                                                       *
;* W = Data Written                                                                               *
;**************************************************************************************************
Wr_Flash
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEDATA
				bcf		STATUS,RP1		;Select Bank 0
				movf	EEADRH2,W
				addlw	0x10			;Mapearlo en el segundo 4K bloque
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEADRH
				bcf		STATUS,RP1		;Select Bank 0
				movf	EEADR2,W
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEADR
				bsf		STATUS,RP0		;Select Bank 3
				bsf		EECON1,EEPGD
				bsf		EECON1,WREN
				movlw	0x55
				movwf	EECON2
				movlw	0xAA
				movwf	EECON2
				bsf		EECON1,WR
				bcf		STATUS,RP0		
				bcf		STATUS,RP1		;Select Bank 0
				btfss	PIR2,EEIF
				goto	$-1
				bcf		PIR2,EEIF
				bsf		STATUS,RP0
				bsf		STATUS,RP1		;Select Bank 3
				bcf		EECON1,WREN
				bcf		STATUS,RP0		;Select Bank 2
				bcf		STATUS,RP1		;Select Bank 0
				return
;**************************************************************************************************
;* READ EXTERNAL EEPROM MEMORY                                                                    *
;**************************************************************************************************
;* EEADRH2:W = Address of Memory                                                                  *
;* W = Data Read                                                                                  *
;**************************************************************************************************
Rd_ExtMem
				movwf   EEADR2
Rd_ExtMem2				
            	call    i2c_controlW
            	movf	EEADRH2,W
            	call	i2c_write_byte
            	movf    EEADR2,W
            	call    i2c_write_byte
Rd_ExtMem_Next
            	call    i2c_controlR
            	call    i2c_read_byte
            	call    i2c_stop
            	movf    EEDATA2,W
				return
;**************************************************************************************************
;* WRITE EXTERNAL EEPROM MEMORY                                                                   *
;**************************************************************************************************
;* EEADRH2:EEADR2 = Address of Flash Memory                                                       *
;* W = Data Written                                                                               *
;**************************************************************************************************
Wr_ExtMem
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEDATA
				bcf		STATUS,RP1		;Select Bank 0
Wr_ExtMem2				
            	call    i2c_controlW
            	movf	EEADRH2,W
            	call	i2c_write_byte
            	movf    EEADR2,W
            	call    i2c_write_byte
				bsf		STATUS,RP1		;Select Bank 2
				movf	EEDATA,W
				bcf		STATUS,RP1		;Select Bank 0
				call    i2c_write_byte
            	goto    i2c_stop
;**************************************************************************************************
;* READ PROGRAM FLASH MEMORY                                                                      *
;**************************************************************************************************
;* EEADRH2:W = Address of Flash Memory                                                            *
;* EEDATH:EEDATA = Data Read                                                                      *
;**************************************************************************************************
Rd_PFlash
				movf	EEADR2,W
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEADR
				bcf		STATUS,RP1		;Select Bank 0
				movf	EEADRH2,W
				bsf		STATUS,RP1		;Select Bank 2
				movwf   EEADRH
				bsf		STATUS,RP1		
            	bsf     STATUS,RP0      ;Select Bank 3
            	bsf		EECON1,EEPGD
            	bsf     EECON1,RD
            	nop						;Any instructions here are ignored as program
            	nop						;memory is read in third cycle after BSF EECON1,RD
            	bcf     STATUS,RP0      ;Select Bank 2
            	bcf		STATUS,RP1		;Select Bank 0				
				return
;**************************************************************************************************
;* WRITE PROGRAM FLASH MEMORY                                                                     *
;**************************************************************************************************
;* EEADRH2:EEADR2 = Address of Flash Memory                                                       *
;* EEDATH:EEDATA = Data to Write                                                                  *
;**************************************************************************************************
Wr_PFlash
				movf	EEADRH2,W
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEADRH
				bcf		STATUS,RP1		;Select Bank 0
				movf	EEADR2,W
				bsf		STATUS,RP1		;Select Bank 2
				movwf	EEADR
				bsf		STATUS,RP0		;Select Bank 3
				bsf		EECON1,EEPGD
				bsf		EECON1,WREN
				movlw	0x55
				movwf	EECON2
				movlw	0xAA
				movwf	EECON2
				bsf		EECON1,WR
				bcf		STATUS,RP0		
				bcf		STATUS,RP1		;Select Bank 0
				btfss	PIR2,EEIF
				goto	$-1
				bcf		PIR2,EEIF
				bsf		STATUS,RP0
				bsf		STATUS,RP1		;Select Bank 3
				bcf		EECON1,WREN
				bcf		STATUS,RP0		;Select Bank 2
				bcf		STATUS,RP1		;Select Bank 0
				return
;**************************************************************************************************
;* LOAD BUFFER                                                                                    *
;**************************************************************************************************
LoadBuffer
				movlw	BUFFER
				movwf	FSR
LoadBuffer_loop
				call	Restore
				movwf	INDF
				incf	FSR,F
				btfss	FSR,3			
				goto	LoadBuffer_loop
				return
;**************************************************************************************************
;* STORE BUFFER                                                                                   *
;**************************************************************************************************
StoreBuffer
				movlw	BUFFER
				movwf	FSR
StoreBuffer_loop
				movf	INDF,W
				call	Store
				incf	FSR,F
				btfss	FSR,3			
				goto	StoreBuffer_loop
				return


;**************************************************************************				
Log
				movlw	0x72			;Comprueba la mscara
				call	Rd_eeprom
				movwf	DUMMY1
				movf	IC_CLA,W
				andwf	DUMMY1,F
				movlw	0x73
				call	Rd_eeprom
				xorwf	DUMMY1,W
				btfss	STATUS,Z
				return
				movlw	0x74
				call	Rd_eeprom
				movwf	DUMMY1
				movf	IC_INS,W
				andwf	DUMMY1,F
				movlw	0x75
				call	Rd_eeprom
				xorwf	DUMMY1,W
				btfss	STATUS,Z
				return
				movlw	0x76
				call	Rd_eeprom
				movwf	DUMMY1
				movf	IC_P1,W
				andwf	DUMMY1,F
				movlw	0x77
				call	Rd_eeprom
				xorwf	DUMMY1,W
				btfss	STATUS,Z
				return
				movlw	0x78
				call	Rd_eeprom
				movwf	DUMMY1
				movf	IC_P2,W
				andwf	DUMMY1,F
				movlw	0x79
				call	Rd_eeprom
				xorwf	DUMMY1,W
				btfss	STATUS,Z
				return
				movlw	0x7A
				call	Rd_eeprom
				movwf	DUMMY1
				movf	IC_P3,W
				andwf	DUMMY1,F
				movlw	0x7B
				call	Rd_eeprom
				xorwf	DUMMY1,W
				btfss	STATUS,Z
				return

				bsf		CONTROL,5
				movlw	0x7C
				call	Rd_eeprom
				addlw	0x0C
				movwf	EEADRH2
				movlw	0x7D
				call	Rd_eeprom
				movwf	EEADR2

				movf	EEADRH2,W
				xorlw	0x10
				btfsc	STATUS,Z		;El buffer est lleno
				goto	Log_full

										;Empiezo con el log (cabecera)
				bsf		LEDS,2			;Led de datos en log
			    movlw   IC_CLA
            	movwf   FSR
Log_loop1    
            	movf   	INDF,W
            	btfss	CONTROL,5
            	goto	End_Log
            	call	StoreLog
            	incf    FSR,f
            	btfsc   FSR,3
            	goto    Log_loop1
            	btfsc	CONTROL2,0		;Si es from CARD to CAM termino
            	goto	End_Log

            	clrf	FSR2
				movf	IC_P3,W
				movwf	COUNTER
Log_loop2	
				call	Restore			;Datos
				btfss	CONTROL,5
				goto	End_Log
				call	StoreLog
				decfsz	COUNTER,f
				goto	Log_loop2

;**************************************************************************
End_Log			movf	EEADR2,W
				movwf	DUMMY1
				movlw	0x7C
				movwf	EEADR2
				movf	EEADRH2,W
				addlw	0xF4
				call	Wr_eeprom
				incf	EEADR2,F
				movf	DUMMY1,W
				call	Wr_eeprom
				bcf		CONTROL,5
				return

;**************************************************************************				
StoreLog
				btfss	CONTROL,5
				return
				call	Wr_Memory
				incf	EEADR2,F
				btfss	STATUS,Z
				return
				incf	EEADRH2,F
				btfss	EEADRH2,4		;El buffer est lleno
				return
				bcf		CONTROL,5
				return

Log_full
				bsf		LEDS,3			;Led de Log lleno
				return

Tabla_conv
				addwf	PCL,f

				retlw	'0'
				retlw	'1'
				retlw	'2'
				retlw	'3'
				retlw	'4'
				retlw	'5'
				retlw	'6'
				retlw	'7'
				retlw	'8'
				retlw	'9'
				retlw	'A'
				retlw	'B'
				retlw	'C'
				retlw	'D'
				retlw	'E'
				retlw	'F'



;**************************************************************************************************
;* Envio del Status Word                                                                          *
;**************************************************************************************************
TX6D00
				movlw	0x6D
				call	Send            	
				movlw	0x00
				call	Send
				goto	Main
TX9002
				movlw	0x90
				call	Send            	
				movlw	0x02
				call	Send
				goto	Main
TX9004
				movlw	0x90
				call	Send            	
				movlw	0x04
				call	Send
				goto	Main
TX9009
				movlw	0x90
				call	Send            	
				movlw	0x09
				call	Send
				goto	Main
TX9010
				movlw	0x90
				call	Send            	
				movlw	0x10
				call	Send
				goto	Main
TX9302									;Ninguna decodificacin
				movlw	0x93
				call	Send            	
				movlw	0x02
				call	Send
				goto	Main
TX9304									;Control Parental demasiado bajo
				movlw	0x93
				call	Send            	
				movlw	0x04
				call	Send
				goto	Main
;**************************************************************************************************
; TABLA1
            	ORG     0x0800
				DT	0x2A,0xE1,0x0B,0x13,0x3E,0x6E,0x32,0x48,0xD3,0x31,0x08,0x8C,0x8F,0x95,0xBD,0xD0
				DT	0xE4,0x6D,0x50,0x81,0x20,0x30,0xBB,0x75,0xF5,0xD4,0x7C,0x87,0x2C,0x4E,0xE8,0xF4
				DT	0xBE,0x24,0x9E,0x4D,0x80,0x37,0xD2,0x5F,0xDB,0x04,0x7A,0x3F,0x14,0x72,0x67,0x2D
				DT	0xCD,0x15,0xA6,0x4C,0x2E,0x3B,0x0C,0x41,0x62,0xFA,0xEE,0x83,0x1E,0xA2,0x01,0x0E
				DT	0x7F,0x59,0xC9,0xB9,0xC4,0x9D,0x9B,0x1B,0x9C,0xCA,0xAF,0x3C,0x73,0x1A,0x65,0xB1
				DT	0x76,0x84,0x39,0x98,0xE9,0x53,0x94,0xBA,0x1D,0x29,0xCF,0xB4,0x0D,0x05,0x7D,0xD1
				DT	0xD7,0x0A,0xA0,0x5C,0x91,0x71,0x92,0x88,0xAB,0x93,0x11,0x8A,0xD6,0x5A,0x77,0xB5
				DT	0xC3,0x19,0xC1,0xC7,0x8E,0xF9,0xEC,0x35,0x4B,0xCC,0xD9,0x4A,0x18,0x23,0x9F,0x52
				DT	0xDD,0xE3,0xAD,0x7B,0x47,0x97,0x60,0x10,0x43,0xEF,0x07,0xA5,0x49,0xC6,0xB3,0x55
				DT	0x28,0x51,0x5D,0x64,0x66,0xFC,0x44,0x42,0xBC,0x26,0x09,0x74,0x6F,0xF7,0x6B,0x4F
				DT	0x2F,0xF0,0xEA,0xB8,0xAE,0xF3,0x63,0x6A,0x56,0xB2,0x02,0xD8,0x34,0xA4,0x00,0xE6
				DT	0x58,0xEB,0xA3,0x82,0x85,0x45,0xE0,0x89,0x7E,0xFD,0xF2,0x3A,0x36,0x57,0xFF,0x06
				DT	0x69,0x54,0x79,0x9A,0xB6,0x6C,0xDC,0x8B,0xA7,0x1F,0x90,0x03,0x17,0x1C,0xED,0xD5
				DT	0xAA,0x5E,0xFE,0xDA,0x78,0xB0,0xBF,0x12,0xA8,0x22,0x21,0x3D,0xC2,0xC0,0xB7,0xA9
				DT	0xE7,0x33,0xFB,0xF1,0x70,0xE5,0x17,0x96,0xF8,0x8D,0x46,0xA1,0x86,0xE2,0x40,0x38
				DT	0xF6,0x68,0x25,0x16,0xAC,0x61,0x27,0xCB,0x5B,0xC8,0x2B,0x0F,0x99,0xDE,0xCE,0xC5
;**************************************************************************************************
; TABLA 2
            	ORG     0x0900
				DT	0xBF,0x11,0x6D,0xFA,0x26,0x7F,0xF3,0xC8,0x9E,0xDD,0x3F,0x16,0x97,0xBD,0x08,0x80
				DT	0x51,0x42,0x93,0x49,0x5B,0x64,0x9B,0x25,0xF5,0x0F,0x24,0x34,0x44,0xB8,0xEE,0x2E
				DT	0xDA,0x8F,0x31,0xCC,0xC0,0x5E,0x8A,0x61,0xA1,0x63,0xC7,0xB2,0x58,0x09,0x4D,0x46
				DT	0x81,0x82,0x68,0x4B,0xF6,0xBC,0x9D,0x03,0xAC,0x91,0xE8,0x3D,0x94,0x37,0xA0,0xBB
				DT	0xCE,0xEB,0x98,0xD8,0x38,0x56,0xE9,0x6B,0x28,0xFD,0x84,0xC6,0xCD,0x5F,0x6E,0xB6
				DT	0x32,0xF7,0x0E,0xF1,0xF8,0x54,0xC1,0x53,0xF0,0xA7,0x95,0x7B,0x19,0x21,0x23,0x7D
				DT	0xE1,0xA9,0x75,0x3E,0xD6,0xED,0x8E,0x6F,0xDB,0xB7,0x07,0x41,0x05,0x77,0xB4,0x2D
				DT	0x45,0xDF,0x29,0x22,0x43,0x89,0x83,0xFC,0xD5,0xA4,0x88,0xD1,0xF4,0x55,0x4F,0x78
				DT	0x62,0x1E,0x1D,0xB9,0xE0,0x2F,0x01,0x13,0x15,0xE6,0x17,0x6A,0x8D,0x0C,0x96,0x7E
				DT	0x86,0x27,0xA6,0x0D,0xB5,0x73,0x71,0xAA,0x36,0xD0,0x06,0x66,0xDC,0xB1,0x2A,0x5A
				DT	0x72,0xBE,0x3A,0xC5,0x40,0x65,0x1B,0x02,0x10,0x9F,0x3B,0xF9,0x2B,0x18,0x5C,0xD7
				DT	0x12,0x47,0xEF,0x1A,0x87,0xD2,0xC2,0x8B,0x99,0x9C,0xD3,0x57,0xE4,0x76,0x67,0xCA
				DT	0x3C,0xFB,0x90,0x20,0x14,0x48,0xC9,0x60,0xB0,0x70,0x4E,0xA2,0xAD,0x35,0xEA,0xC4
				DT	0x74,0xCB,0x39,0xDE,0xE7,0xD4,0xA3,0xA5,0x04,0x92,0x8C,0xD9,0x7C,0x1C,0x7A,0xA8
				DT	0x52,0x79,0xF2,0x33,0xBA,0x1F,0x30,0x9A,0x00,0x50,0x4C,0xFF,0xE5,0xCF,0x59,0xC3
				DT	0xE3,0x0A,0x85,0xB3,0xAE,0xEC,0x0B,0xFE,0xE2,0xAB,0x4A,0xAF,0x69,0x6C,0x2C,0x5D
;**************************************************************************************************
;* ZONA DE DATOS                                                                                  *
;**************************************************************************************************
				ORG		0x1000
I0E_ANS			DW		0x00,0x25,0x00,0x00,0x00,0x07,0x5B,0xCD
I16_ANS			DW		0x00,0x00,0x00,0x03,0x00,0x00,0xFF,0xFF
P00_INFO		DW		0x00,0x00,0x53,0x45,0x43,0x41,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P01_INFO		DW		0x00,0x0C,0x46,0x53,0x20,0x43,0x53,0x45,0x20,0x54,0x61,0x71,0x75,0x69,0x6C,0x61,0x20,0x20,0x00,0x07,0x29,0x04,0x15,0x9F
P02_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P03_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P04_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P05_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P06_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P07_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P08_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P09_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P0A_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P0B_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P0C_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P0D_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P0E_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
P0F_INFO		DW		0x00,0x00,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF
				DW		0,0,0,0,0,0,0,0,0
I32_ANS			DW		0xB2,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x04
I1A_ANS			DW		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x61,0x19,0xAD,0xCA,0x15,0x2F,0x10,0x03,0x00,0x00,0xFF,0xFF,0xFF,0xFF
;**************************************************************************************************
;* PBMS DE LOS PROVEEDORES                                                                        *
;**************************************************************************************************
				ORG		0x1200
PBM00			DW		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF			
PBM01			DW		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF			
PBM02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM04			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM05			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM06			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM07			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM08			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM09			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM0A			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM0B			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
PBM0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
I0A_ANS			DW		0x61,0x19,0xAD,0xCA,0x15,0x2F,0x10,0x03,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
				DW		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x28,0x43,0x29,0x43,0x41,0x4E
				DW		0x41,0x4C,0x2B,0x31,0x39,0x39,0x34,0x2F,0x39,0x35,0x2F,0x39,0x36,0x20,0x4E,0x75,0x6D,0x34,0x30,0x00
;**************************************************************************************************
;* CLAVES PRIMARIAS DE LOS PROVEEDORES                                                            *
;**************************************************************************************************
				ORG		0x1400
P00MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P01MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01MK01			DW		0x2B,0xED,0xC1,0x26,0xBA,0x19,0x8F,0xF0
P01MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01PK0C			DW		0xAE,0x50,0xD2,0xBF,0x91,0x8A,0x4A,0xD7
P01PK0D			DW		0xCA,0x5C,0xB2,0xC2,0xED,0xF9,0x3C,0xE0
P01PK0E			DW		0x5A,0x1D,0xB3,0xDD,0x48,0x22,0x12,0x31
P01PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P02MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P03MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P04MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P05MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P06MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P07MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P08MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P09MK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09MK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09MK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09MK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09PK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09PK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09PK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09PK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P0AMK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0AMK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0AMK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0AMK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0APK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0APK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0APK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0APK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P0BMK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BMK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BMK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BMK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BPK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BPK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BPK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BPK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P0CMK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CMK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CMK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CMK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CPK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CPK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CPK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CPK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P0DMK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DMK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DMK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DMK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DPK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DPK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DPK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DPK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P0EMK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EMK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EMK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EMK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EPK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EPK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EPK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EPK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
P0FMK00			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FMK01			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FMK02			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FMK03			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FPK0C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FPK0D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FPK0E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FPK0F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
;* CLAVES SECUNDARIAS DE LOS PROVEEDORES                                                          *
;**************************************************************************************************
P00MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P00PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P01PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P02PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P03PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P04PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P05PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P06PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P07PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P08PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09MK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09MK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09MK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09MK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09PK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09PK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09PK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P09PK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0AMK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0AMK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0AMK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0AMK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0APK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0APK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0APK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0APK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BMK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BMK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BMK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BMK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BPK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BPK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BPK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0BPK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CMK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CMK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CMK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CMK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CPK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CPK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CPK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0CPK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DMK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DMK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DMK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DMK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DPK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DPK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DPK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0DPK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EMK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EMK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EMK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EMK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EPK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EPK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EPK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0EPK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FMK10			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FMK11			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FMK12			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FMK13			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FPK1C			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FPK1D			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FPK1E			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
P0FPK1F			DW		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;**************************************************************************************************
;* EEPROM INTERNA DEL F876                                                                        *
;**************************************************************************************************
            	ORG     0x2100
CONFIGBYTE		DATA	0x04
ATR				DATA    0xD6,0xB6,0x6C,0x0E,0x04,0x30,0x54,0x96,0x40,0x01,0x00,0x11,0xF7,0x3B
COMMANDS		DATA	0x0E,0x16,0x12,0x34,0x32,0x22,0x30,0x20,0x3A,0x3C,0x40,0x1A,0x5A,0x24,0x26,0x28,0x0A
				ORG		0x212E
PIN				DATA	0,0
            	ORG     0x2130
            	DATA    0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
            	ORG		0x2140
PASSWORD       	DATA	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
            	ORG		0x2150
PROVIDER		DATA	0
PROVINFO		DATA	0x00,0x00,0x53,0x45,0x43,0x41,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0xFF,0xFF           	
				DATA	0
PROVPBM			DATA	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF			
CONFIGLOG		DATA	0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
LOGCOUNTER		DATA	0x00,0x00
BAUDRATE		DATA	0x05	;9322 bps @ 3.579545 MHz 
;========================================
				ORG		0x2180
;* Claves del proveedor cargado PK+SK 8*8+8*8 = 128 bytes				            	
;******************************************************************************
            	END
